Fixed crash calculating trimmed mean with missing values.
authorJohn Darrington <john@darrington.wattle.id.au>
Fri, 8 May 2009 10:56:36 +0000 (18:56 +0800)
committerJohn Darrington <john@darrington.wattle.id.au>
Fri, 8 May 2009 10:56:36 +0000 (18:56 +0800)
Closes bug  #26404

src/language/stats/examine.q
tests/automake.mk
tests/bugs/examine-crash3.sh [new file with mode: 0755]

index 51f2832052e57461e628b96353c4d16b3101f6d4..3d0b077c5fa9a04720163bac05e663d2d5680636 100644 (file)
@@ -1005,8 +1005,8 @@ examine_group (struct cmd_examine *cmd, struct casereader *reader, int level,
                metric->quartiles[2] = metric->ptl[i];
            }
 
-         metric->tukey_hinges = tukey_hinges_create (metric->n, metric->cmin);
-         metric->trimmed_mean = trimmed_mean_create (metric->n, 0.05);
+         metric->tukey_hinges = tukey_hinges_create (metric->n_valid, metric->cmin);
+         metric->trimmed_mean = trimmed_mean_create (metric->n_valid, 0.05);
 
          n_os = metric->n_ptiles + 2;
 
index 2384f9d6fb48c21f048601529618075399bf2398..1e3b3a97d6a834ebce6e5031e12f300d63833ba6 100644 (file)
@@ -118,6 +118,7 @@ dist_TESTS = \
        tests/bugs/get.sh \
        tests/bugs/examine-crash.sh \
        tests/bugs/examine-crash2.sh \
+       tests/bugs/examine-crash3.sh \
        tests/bugs/examine-1sample.sh \
        tests/bugs/examine-missing.sh \
        tests/bugs/examine-missing2.sh \
diff --git a/tests/bugs/examine-crash3.sh b/tests/bugs/examine-crash3.sh
new file mode 100755 (executable)
index 0000000..6093c34
--- /dev/null
@@ -0,0 +1,82 @@
+#!/bin/sh
+
+# This program tests for a bug which crashed pspp
+# when the /DESCRIPTIVES subcommand of EXAMINE
+# encountered missing values.
+
+TEMPDIR=/tmp/pspp-tst-$$
+TESTFILE=$TEMPDIR/`basename $0`.sps
+
+# ensure that top_srcdir and top_builddir  are absolute
+if [ -z "$top_srcdir" ] ; then top_srcdir=. ; fi
+if [ -z "$top_builddir" ] ; then top_builddir=. ; fi
+top_srcdir=`cd $top_srcdir; pwd`
+top_builddir=`cd $top_builddir; pwd`
+
+PSPP=$top_builddir/src/ui/terminal/pspp
+
+STAT_CONFIG_PATH=$top_srcdir/config
+export STAT_CONFIG_PATH
+
+LANG=C
+export LANG
+
+
+cleanup()
+{
+     if [ x"$PSPP_TEST_NO_CLEANUP" != x ] ; then 
+       echo "NOT cleaning $TEMPDIR"
+       return ; 
+     fi
+     rm -rf $TEMPDIR
+}
+
+
+fail()
+{
+    echo $activity
+    echo FAILED
+    cleanup;
+    exit 1;
+}
+
+
+no_result()
+{
+    echo $activity
+    echo NO RESULT;
+    cleanup;
+    exit 2;
+}
+
+pass()
+{
+    cleanup;
+    exit 0;
+}
+
+mkdir -p $TEMPDIR
+
+cd $TEMPDIR
+
+activity="create program"
+cat <<EOF > $TESTFILE
+data list list /x * y *.
+begin data.
+1 0
+2 0
+. 0
+3 1
+4 1
+end data.
+examine x by y /statistics=descriptives. 
+EOF
+if [ $? -ne 0 ] ; then no_result ; fi
+
+
+activity="run program"
+$SUPERVISOR $PSPP --testing-mode -o raw-ascii $TESTFILE
+if [ $? -ne 0 ] ; then fail ; fi
+
+
+pass;